# Uses of Class
org.apache.solr.common.cloud.DocRouter

Packages that use DocRouter
Package
Description
org.apache.solr.client.solrj.impl
Implementations of some client API classes, and their friends.
org.apache.solr.client.solrj.request
Convenience classes for dealing with various types of Solr requests.
org.apache.solr.common.cloud
Common Solr Cloud and ZooKeeper related classes reused on both clients & server.

## Uses of DocRouter in org.apache.solr.client.solrj.impl

Methods in org.apache.solr.client.solrj.impl with parameters of type DocRouter
Modifier and Type
Method
Description
`protected Map<String,? extends LBSolrClient.Req>`
CloudSolrClient.`createRoutes(UpdateRequest updateRequest, ModifiableSolrParams routableParams, DocCollection col, DocRouter router, Map<String,List<String>> urlMap, String routeField)`

## Uses of DocRouter in org.apache.solr.client.solrj.request

Methods in org.apache.solr.client.solrj.request with parameters of type DocRouter
Modifier and Type
Method
Description
`Map<String,LBSolrClient.Req>`
UpdateRequest.`getRoutesToCollection(DocRouter router, DocCollection col, Map<String,List<String>> urlMap, ModifiableSolrParams params, String idField)`

## Uses of DocRouter in org.apache.solr.common.cloud

Subclasses of DocRouter in org.apache.solr.common.cloud
Modifier and Type
Class
Description
`class`
`CompositeIdRouter`
CompositeIdRouter partitions ids based on a `CompositeIdRouter.SEPARATOR`, hashes each partition and merges the hashes together to map the id to a slice.
`class`
`HashBasedRouter`
`class`
`ImplicitDocRouter`
This document router is for custom sharding
`class`
`PlainIdRouter`
Fields in org.apache.solr.common.cloud declared as DocRouter
Modifier and Type
Field
Description
`static final DocRouter`
DocRouter.`DEFAULT`
Methods in org.apache.solr.common.cloud that return DocRouter
Modifier and Type
Method
Description
`static DocRouter`
DocRouter.`getDocRouter(String routerName)`
`DocRouter`
DocCollection.`getRouter()`
Methods in org.apache.solr.common.cloud with parameters of type DocRouter
Modifier and Type
Method
Description
`static DocCollection`
DocCollection.`create(String name, Map<String,Slice> slices, Map<String,Object> props, DocRouter router, int zkVersion, Instant creationTime, DocCollection.PrsSupplier prsSupplier)`
Builds a DocCollection with an optional PrsSupplier